Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3382)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3418)
@@ -4815,25 +5865,25 @@
                  IF ( building_pars_f%pars_xy(ind_thick_4,j,i) /= building_pars_f%fill )    & 
                     surf_usm_v(l)%zw_green(nzb_wall+3,m) = building_pars_f%pars_xy(ind_thick_4,j,i)
-                 IF ( building_pars_f%pars_xy(ind_thick_1,j,i) /= building_pars_f%fill )    & 
-                    surf_usm_v(l)%zw_window(nzb_wall,m) = building_pars_f%pars_xy(ind_thick_1,j,i)
-                 IF ( building_pars_f%pars_xy(ind_thick_2,j,i) /= building_pars_f%fill )    & 
-                    surf_usm_v(l)%zw_window(nzb_wall+1,m) = building_pars_f%pars_xy(ind_thick_2,j,i)
-                 IF ( building_pars_f%pars_xy(ind_thick_3,j,i) /= building_pars_f%fill )    & 
-                    surf_usm_v(l)%zw_window(nzb_wall+2,m) = building_pars_f%pars_xy(ind_thick_3,j,i)
-                 IF ( building_pars_f%pars_xy(ind_thick_4,j,i) /= building_pars_f%fill )    & 
-                    surf_usm_v(l)%zw_window(nzb_wall+3,m) = building_pars_f%pars_xy(ind_thick_4,j,i)
-
-                 IF ( building_pars_f%pars_xy(45,j,i) /= building_pars_f%fill )    & 
-                    surf_usm_v(l)%c_surface(m)           = building_pars_f%pars_xy(45,j,i)
-                 IF ( building_pars_f%pars_xy(46,j,i) /= building_pars_f%fill )    & 
-                    surf_usm_v(l)%lambda_surf(m)         = building_pars_f%pars_xy(46,j,i)
-                 IF ( building_pars_f%pars_xy(45,j,i) /= building_pars_f%fill )    & 
-                    surf_usm_v(l)%c_surface_green(m)     = building_pars_f%pars_xy(45,j,i)
-                 IF ( building_pars_f%pars_xy(46,j,i) /= building_pars_f%fill )    & 
-                    surf_usm_v(l)%lambda_surf_green(m)   = building_pars_f%pars_xy(46,j,i)
-                 IF ( building_pars_f%pars_xy(45,j,i) /= building_pars_f%fill )    & 
-                    surf_usm_v(l)%c_surface_window(m)    = building_pars_f%pars_xy(45,j,i)
-                 IF ( building_pars_f%pars_xy(46,j,i) /= building_pars_f%fill )    & 
-                    surf_usm_v(l)%lambda_surf_window(m)  = building_pars_f%pars_xy(46,j,i)
+                 IF ( building_pars_f%pars_xy(ind_thick_1_win,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%zw_window(nzb_wall,m) = building_pars_f%pars_xy(ind_thick_1_win,j,i)
+                 IF ( building_pars_f%pars_xy(ind_thick_2_win,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%zw_window(nzb_wall+1,m) = building_pars_f%pars_xy(ind_thick_2_win,j,i)
+                 IF ( building_pars_f%pars_xy(ind_thick_3_win,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%zw_window(nzb_wall+2,m) = building_pars_f%pars_xy(ind_thick_3_win,j,i)
+                 IF ( building_pars_f%pars_xy(ind_thick_4_win,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%zw_window(nzb_wall+3,m) = building_pars_f%pars_xy(ind_thick_4_win,j,i)
+
+                 IF ( building_pars_f%pars_xy(0,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%c_surface(m)           = building_pars_f%pars_xy(0,j,i)
+                 IF ( building_pars_f%pars_xy(3,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%lambda_surf(m)         = building_pars_f%pars_xy(3,j,i)
+                 IF ( building_pars_f%pars_xy(2,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%c_surface_green(m)     = building_pars_f%pars_xy(2,j,i)
+                 IF ( building_pars_f%pars_xy(5,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%lambda_surf_green(m)   = building_pars_f%pars_xy(5,j,i)
+                 IF ( building_pars_f%pars_xy(1,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%c_surface_window(m)    = building_pars_f%pars_xy(1,j,i)
+                 IF ( building_pars_f%pars_xy(4,j,i) /= building_pars_f%fill )    & 
+                    surf_usm_v(l)%lambda_surf_window(m)  = building_pars_f%pars_xy(4,j,i)
 
               ENDDO
@@ -4945,5 +5995,5 @@
 
 !
-!--         At horizontal surfaces. Please note, t_surf_h is defined on a 
+!--         At horizontal surfaces. Please note, t_surf_wall_h is defined on a 
 !--         different data type, but with the same dimension.
 #if ! defined( __nopointer )
@@ -4953,5 +6003,5 @@
                k = surf_usm_h%k(m)
 
-               t_surf_h(m) = pt(k,j,i) * exner(k)
+               t_surf_wall_h(m) = pt(k,j,i) * exner(k)
                t_surf_window_h(m) = pt(k,j,i) * exner(k)
                t_surf_green_h(m) = pt(k,j,i) * exner(k)
@@ -4966,5 +6016,5 @@
                   k = surf_usm_v(l)%k(m)
 
-                  t_surf_v(l)%t(m) = pt(k,j,i) * exner(k)
+                  t_surf_wall_v(l)%t(m) = pt(k,j,i) * exner(k)
                   t_surf_window_v(l)%t(m) = pt(k,j,i) * exner(k)
                   t_surf_green_v(l)%t(m) = pt(k,j,i) * exner(k)
@@ -5009,7 +6059,13 @@
                        REAL( nzt_wall + 1 - nzb_wall , wp )
 
-                   t_wall_h(k,m) = ( 1.0_wp - c ) * t_surf_h(m) + c * tin
+                   t_wall_h(k,m) = ( 1.0_wp - c ) * t_surf_wall_h(m) + c * tin
                    t_window_h(k,m) = ( 1.0_wp - c ) * t_surf_window_h(m) + c * twin
-                   t_green_h(k,m) = t_surf_h(m)
+                   t_green_h(k,m) = t_surf_wall_h(m)
+                   swc_h(k,m) = 0.5_wp
+                   swc_sat_h(k,m) = 0.95_wp
+                   swc_res_h(k,m) = 0.05_wp
+                   rootfr_h(k,m) = 0.1_wp
+                   wilt_h(k,m) = 0.1_wp
+                   fc_h(k,m) = 0.9_wp
                ENDDO
             ENDDO
@@ -5026,7 +6082,8 @@
                      c = REAL( k - nzb_wall, wp ) /                            &
                          REAL( nzt_wall + 1 - nzb_wall , wp )
-                     t_wall_v(l)%t(k,m) = ( 1.0_wp - c ) * t_surf_v(l)%t(m) + c * tin
+                     t_wall_v(l)%t(k,m) = ( 1.0_wp - c ) * t_surf_wall_v(l)%t(m) + c * tin
                      t_window_v(l)%t(k,m) = ( 1.0_wp - c ) * t_surf_window_v(l)%t(m) + c * twin
-                     t_green_v(l)%t(k,m) = t_surf_v(l)%t(m)
+                     t_green_v(l)%t(k,m) = t_surf_wall_v(l)%t(m)
+                     swc_v(l)%t(k,m) = 0.5_wp
                   ENDDO
                ENDDO
@@ -5043,6 +6100,6 @@
 
 !--     initialize prognostic values for the first timestep
-        t_surf_h_p = t_surf_h
-        t_surf_v_p = t_surf_v
+        t_surf_wall_h_p = t_surf_wall_h
+        t_surf_wall_v_p = t_surf_wall_v
         t_surf_window_h_p = t_surf_window_h
         t_surf_window_v_p = t_surf_window_v
@@ -5064,4 +6121,37 @@
 !--     that is not yet possible.
         
+        m_liq_usm_h_p     = m_liq_usm_h
+        m_liq_usm_v_p     = m_liq_usm_v
+!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+!
+!--    Set initial values for prognostic quantities
+!--    Horizontal surfaces
+       tm_liq_usm_h_m%var_usm_1d  = 0.0_wp
+       surf_usm_h%c_liq = 0.0_wp
+
+       surf_usm_h%qsws_liq_eb  = 0.0_wp
+       surf_usm_h%qsws_veg_eb  = 0.0_wp
+
+!
+!--    Do the same for vertical surfaces
+       DO  l = 0, 3
+          tm_liq_usm_v_m(l)%var_usm_1d  = 0.0_wp
+          surf_usm_v(l)%c_liq = 0.0_wp
+
+          surf_usm_v(l)%qsws_liq_eb  = 0.0_wp
+          surf_usm_v(l)%qsws_veg_eb  = 0.0_wp
+       ENDDO
+
+!
+!--    Set initial values for prognostic soil quantities
+       IF ( TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
+          m_liq_usm_h%var_usm_1d  = 0.0_wp
+
+          DO  l = 0, 3
+             m_liq_usm_v(l)%var_usm_1d  = 0.0_wp
+          ENDDO
+       ENDIF
+!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++        
+
         CALL cpu_log( log_point_s(78), 'usm_init', 'stop' )
 
@@ -5076,5 +6166,5 @@
 !> temperature.
 !------------------------------------------------------------------------------!
-    SUBROUTINE usm_material_heat_model
+    SUBROUTINE usm_material_heat_model( spinup )
 
 
@@ -5084,4 +6174,15 @@
 
         REAL(wp), DIMENSION(nzb_wall:nzt_wall) :: wtend, wintend  !< tendency
+        REAL(wp)     :: win_absorp !absorption coefficient from transmissivity
+        REAL(wp), DIMENSION(nzb_wall:nzt_wall) :: wall_mod
+
+        LOGICAL      :: spinup !if true, no calculation of window temperatures
+
+        wall_mod=1.0_wp
+        if (usm_wall_mod .AND. spinup) then
+          do kw=nzb_wall,nzb_wall+1
+            wall_mod(kw)=0.1_wp
+          enddo
+        endif
 
 !
@@ -5097,5 +6198,5 @@
            wtend(:) = 0.0_wp
            wtend(nzb_wall) = (1.0_wp / surf_usm_h%rho_c_wall(nzb_wall,m)) *        &
-                                       ( surf_usm_h%lambda_h(nzb_wall,m) *         &
+                                       ( surf_usm_h%lambda_h(nzb_wall,m) * wall_mod(nzb_wall) *        &
                                          ( t_wall_h(nzb_wall+1,m)                  &
                                          - t_wall_h(nzb_wall,m) ) *                &
@@ -5108,7 +6209,7 @@
                                           / (surf_usm_h%frac(ind_veg_wall,m)       &
                                             + surf_usm_h%frac(ind_pav_green,m) )   &
-                                         * ( surf_usm_h%lambda_h_green(nzt_wall,m) &
+                                         * ( surf_usm_h%lambda_h_green(nzt_wall,m)* wall_mod(nzt_wall) &
                                            * surf_usm_h%ddz_green(nzt_wall,m)      &
-                                           + surf_usm_h%lambda_h(nzb_wall,m)       &
+                                           + surf_usm_h%lambda_h(nzb_wall,m) * wall_mod(nzb_wall)        &
                                            * surf_usm_h%ddz_wall(nzb_wall,m) )     &
                                          / ( surf_usm_h%ddz_green(nzt_wall,m)      &
@@ -5118,14 +6219,11 @@
                                        surf_usm_h%ddz_wall_stag(nzb_wall,m)
 
-!dummy value for testing
-surf_usm_h%iwghf_eb(m) = 0.
-
            IF ( indoor_model ) then 
               DO  kw = nzb_wall+1, nzt_wall-1
                   wtend(kw) = (1.0_wp / surf_usm_h%rho_c_wall(kw,m))              &
-                                 * (   surf_usm_h%lambda_h(kw,m)                  &
+                                 * (   surf_usm_h%lambda_h(kw,m) * wall_mod(kw)                 &
                                     * ( t_wall_h(kw+1,m) - t_wall_h(kw,m) )       &
                                     * surf_usm_h%ddz_wall(kw+1,m)                 &
-                                 - surf_usm_h%lambda_h(kw-1,m)                    &
+                                 - surf_usm_h%lambda_h(kw-1,m) * wall_mod(kw-1)                     &
                                     * ( t_wall_h(kw,m) - t_wall_h(kw-1,m) )       &
                                     * surf_usm_h%ddz_wall(kw,m)                   &
@@ -5133,5 +6231,5 @@
               ENDDO
               wtend(nzt_wall) = (1.0_wp / surf_usm_h%rho_c_wall(nzt_wall,m)) *    &
-                                         ( surf_usm_h%lambda_h(nzt_wall-1,m) *    &
+                                         ( -surf_usm_h%lambda_h(nzt_wall-1,m) * wall_mod(nzt_wall-1) *     &
                                            ( t_wall_h(nzt_wall,m)                 &
                                            - t_wall_h(nzt_wall-1,m) ) *           &
@@ -5142,8 +6240,8 @@
               DO  kw = nzb_wall+1, nzt_wall
                   wtend(kw) = (1.0_wp / surf_usm_h%rho_c_wall(kw,m))              &
-                                 * (   surf_usm_h%lambda_h(kw,m)                  &
+                                 * (   surf_usm_h%lambda_h(kw,m)  * wall_mod(kw)                &
                                     * ( t_wall_h(kw+1,m) - t_wall_h(kw,m) )       &
                                     * surf_usm_h%ddz_wall(kw+1,m)                 &
-                                 - surf_usm_h%lambda_h(kw-1,m)                    &
+                                 - surf_usm_h%lambda_h(kw-1,m) * wall_mod(kw-1)                   &
                                     * ( t_wall_h(kw,m) - t_wall_h(kw-1,m) )       &
                                     * surf_usm_h%ddz_wall(kw,m)                   &
@@ -5157,4 +6255,6 @@
                                  * surf_usm_h%tt_wall_m(nzb_wall:nzt_wall,m) )   
 
+if (.NOT. spinup) then
+           win_absorp = -log(surf_usm_h%transmissivity(m)) / surf_usm_h%zw_window(nzt_wall,m)
 !--        prognostic equation for ground/roof window temperature t_window_h
            wintend(:) = 0.0_wp
@@ -5166,5 +6266,5 @@
                                       + surf_usm_h%wghf_eb_window(m)              &
                                       + surf_usm_h%rad_sw_in(m)                   &
-                                        * (1.0_wp - exp(-surf_usm_h%transmissivity(m) &
+                                        * (1.0_wp - exp(-win_absorp               &
                                         * surf_usm_h%zw_window(nzb_wall,m) ) )    &
                                       ) * surf_usm_h%ddz_window_stag(nzb_wall,m)
@@ -5180,20 +6280,22 @@
                                     * surf_usm_h%ddz_window(kw,m)                 &
                                  + surf_usm_h%rad_sw_in(m)                        &
-                                    * (exp(-surf_usm_h%transmissivity(m)       &
+                                    * (exp(-win_absorp                            &
                                         * surf_usm_h%zw_window(kw-1,m) )          &
-                                        - exp(-surf_usm_h%transmissivity(m)    &
+                                        - exp(-win_absorp                         &
                                         * surf_usm_h%zw_window(kw,m) ) )          &
                                    ) * surf_usm_h%ddz_window_stag(kw,m)
 
               ENDDO
-              wintend(nzt_wall) = (1.0_wp / surf_usm_h%rho_c_window(nzt_wall,m)) *     &
-                                         ( surf_usm_h%lambda_h_window(nzt_wall-1,m) *  &
-                                           ( t_window_h(nzt_wall,m)                    &
-                                           - t_window_h(nzt_wall-1,m) ) *              &
-                                           surf_usm_h%ddz_window(nzt_wall,m)           &
-                                         + surf_usm_h%iwghf_eb_window(m)               &
-                                         + surf_usm_h%rad_sw_in(m)                     &
-                                           * (1.0_wp - exp(-surf_usm_h%transmissivity(m) &
-                                           * surf_usm_h%zw_window(nzt_wall,m) ) )      &
+              wintend(nzt_wall) = (1.0_wp / surf_usm_h%rho_c_window(nzt_wall,m)) *       &
+                                         ( -surf_usm_h%lambda_h_window(nzt_wall-1,m) *   &
+                                           ( t_window_h(nzt_wall,m)                      &
+                                           - t_window_h(nzt_wall-1,m) ) *                &
+                                           surf_usm_h%ddz_window(nzt_wall,m)             &
+                                         + surf_usm_h%iwghf_eb_window(m)                 &
+                                         + surf_usm_h%rad_sw_in(m)                       &
+                                           * (exp(-win_absorp                            &
+                                           * surf_usm_h%zw_window(nzt_wall-1,m) )        &
+                                           - exp(-win_absorp                             &
+                                           * surf_usm_h%zw_window(nzt_wall,m) ) )        &
                                          ) * surf_usm_h%ddz_window_stag(nzt_wall,m)
            ELSE
@@ -5207,7 +6309,7 @@
                                     * surf_usm_h%ddz_window(kw,m)                 &
                                  + surf_usm_h%rad_sw_in(m)                        &
-                                    * (exp(-surf_usm_h%transmissivity(m)       &
+                                    * (exp(-win_absorp                            &
                                         * surf_usm_h%zw_window(kw-1,m) )          &
-                                        - exp(-surf_usm_h%transmissivity(m)    &
+                                        - exp(-win_absorp                         &
                                         * surf_usm_h%zw_window(kw,m) ) )          &
                                    ) * surf_usm_h%ddz_window_stag(kw,m)
@@ -5220,4 +6322,6 @@
                                  * wintend(nzb_wall:nzt_wall) + tsc(3)            &
                                  * surf_usm_h%tt_window_m(nzb_wall:nzt_wall,m) )   
+
+endif
 
 !
@@ -5237,4 +6341,5 @@
            ENDIF
 
+if (.NOT. spinup) then
 !--        calculate t_window tendencies for the next Runge-Kutta step
            IF ( timestep_scheme(1:5) == 'runge' )  THEN
@@ -5251,4 +6356,7 @@
                ENDIF
            ENDIF
+
+endif
+
         ENDDO
 
@@ -5267,5 +6375,5 @@
 
                wtend(nzb_wall) = (1.0_wp / surf_usm_v(l)%rho_c_wall(nzb_wall,m)) *    &
-                                       ( surf_usm_v(l)%lambda_h(nzb_wall,m) *         &
+                                       ( surf_usm_v(l)%lambda_h(nzb_wall,m) * wall_mod(nzb_wall)  *      &
                                          ( t_wall_v(l)%t(nzb_wall+1,m)                &
                                          - t_wall_v(l)%t(nzb_wall,m) ) *              &
@@ -5278,7 +6386,7 @@
                                          / (surf_usm_v(l)%frac(ind_veg_wall,m)        &
                                            + surf_usm_v(l)%frac(ind_pav_green,m) )    &
-                                         * ( surf_usm_v(l)%lambda_h_green(nzt_wall,m) &
+                                         * ( surf_usm_v(l)%lambda_h_green(nzt_wall,m)* wall_mod(nzt_wall) &
                                            * surf_usm_v(l)%ddz_green(nzt_wall,m)      &
-                                           + surf_usm_v(l)%lambda_h(nzb_wall,m)       &
+                                           + surf_usm_v(l)%lambda_h(nzb_wall,m)* wall_mod(nzb_wall)       &
                                            * surf_usm_v(l)%ddz_wall(nzb_wall,m) )     &
                                          / ( surf_usm_v(l)%ddz_green(nzt_wall,m)      &
@@ -5288,14 +6396,11 @@
                                          surf_usm_v(l)%ddz_wall_stag(nzb_wall,m)
 
-!dummy value for testing
-surf_usm_v(l)%iwghf_eb(m) = 0.
-
               IF ( indoor_model ) then 
                  DO  kw = nzb_wall+1, nzt_wall-1
                      wtend(kw) = (1.0_wp / surf_usm_v(l)%rho_c_wall(kw,m))        &
-                              * (   surf_usm_v(l)%lambda_h(kw,m)                  &
+                              * (   surf_usm_v(l)%lambda_h(kw,m)  * wall_mod(kw)                &
                                  * ( t_wall_v(l)%t(kw+1,m) - t_wall_v(l)%t(kw,m) )&
                                  * surf_usm_v(l)%ddz_wall(kw+1,m)                 &
-                              - surf_usm_v(l)%lambda_h(kw-1,m)                    &
+                              - surf_usm_v(l)%lambda_h(kw-1,m)  * wall_mod(kw-1)                  &
                                  * ( t_wall_v(l)%t(kw,m) - t_wall_v(l)%t(kw-1,m) )&
                                  * surf_usm_v(l)%ddz_wall(kw,m)                   &
@@ -5303,5 +6408,5 @@
                  ENDDO
                  wtend(nzt_wall) = (1.0_wp / surf_usm_v(l)%rho_c_wall(nzt_wall,m)) * &
-                                         ( surf_usm_v(l)%lambda_h(nzt_wall-1,m) *    &
+                                         ( -surf_usm_v(l)%lambda_h(nzt_wall-1,m) * wall_mod(nzt_wall-1)*    &
                                            ( t_wall_v(l)%t(nzt_wall,m)               &
                                            - t_wall_v(l)%t(nzt_wall-1,m) ) *         &
@@ -5312,8 +6417,8 @@
                  DO  kw = nzb_wall+1, nzt_wall
                      wtend(kw) = (1.0_wp / surf_usm_v(l)%rho_c_wall(kw,m))        &
-                              * (   surf_usm_v(l)%lambda_h(kw,m)                  &
+                              * (   surf_usm_v(l)%lambda_h(kw,m) * wall_mod(kw)                 &
                                  * ( t_wall_v(l)%t(kw+1,m) - t_wall_v(l)%t(kw,m) )&
                                  * surf_usm_v(l)%ddz_wall(kw+1,m)                 &
-                              - surf_usm_v(l)%lambda_h(kw-1,m)                    &
+                              - surf_usm_v(l)%lambda_h(kw-1,m)  * wall_mod(kw-1)                  &
                                  * ( t_wall_v(l)%t(kw,m) - t_wall_v(l)%t(kw-1,m) )&
                                  * surf_usm_v(l)%ddz_wall(kw,m)                   &
@@ -5328,4 +6433,6 @@
                                  * surf_usm_v(l)%tt_wall_m(nzb_wall:nzt_wall,m) )   
 
+if (.NOT. spinup) then
+              win_absorp = -log(surf_usm_v(l)%transmissivity(m)) / surf_usm_v(l)%zw_window(nzt_wall,m)
 !--           prognostic equation for window temperature t_window_v
               wintend(:) = 0.0_wp
@@ -5337,5 +6444,5 @@
                                       + surf_usm_v(l)%wghf_eb_window(m)               &
                                       + surf_usm_v(l)%rad_sw_in(m)                    &
-                                        * (1.0_wp - exp(-surf_usm_v(l)%transmissivity(m) &
+                                        * (1.0_wp - exp(-win_absorp                   &
                                         * surf_usm_v(l)%zw_window(nzb_wall,m) ) )     &
                                       ) * surf_usm_v(l)%ddz_window_stag(nzb_wall,m)
@@ -5351,19 +6458,21 @@
                                  * surf_usm_v(l)%ddz_window(kw,m)                      &
                               + surf_usm_v(l)%rad_sw_in(m)                             &
-                                 * (exp(-surf_usm_v(l)%transmissivity(m)            &
+                                 * (exp(-win_absorp                                    &
                                     * surf_usm_v(l)%zw_window(kw-1,m)       )          &
-                                        - exp(-surf_usm_v(l)%transmissivity(m)      &
+                                        - exp(-win_absorp                              &
                                         * surf_usm_v(l)%zw_window(kw,m) ) )            &
                                  ) * surf_usm_v(l)%ddz_window_stag(kw,m)
                   ENDDO
-                  wintend(nzt_wall) = (1.0_wp / surf_usm_v(l)%rho_c_window(nzt_wall,m)) * &
-                                          ( surf_usm_v(l)%lambda_h_window(nzt_wall-1,m) * &
-                                            ( t_window_v(l)%t(nzt_wall,m)                 &
-                                            - t_window_v(l)%t(nzt_wall-1,m) ) *           &
-                                            surf_usm_v(l)%ddz_window(nzt_wall,m)          &
-                                          + surf_usm_v(l)%iwghf_eb_window(m)              &
-                                          + surf_usm_v(l)%rad_sw_in(m)                    &
-                                            * (1.0_wp - exp(-surf_usm_v(l)%transmissivity(m) &
-                                            * surf_usm_v(l)%zw_window(nzt_wall,m) ) )     &
+                  wintend(nzt_wall) = (1.0_wp / surf_usm_v(l)%rho_c_window(nzt_wall,m)) *  &
+                                          ( -surf_usm_v(l)%lambda_h_window(nzt_wall-1,m) * &
+                                            ( t_window_v(l)%t(nzt_wall,m)                  &
+                                            - t_window_v(l)%t(nzt_wall-1,m) ) *            &
+                                            surf_usm_v(l)%ddz_window(nzt_wall,m)           &
+                                          + surf_usm_v(l)%iwghf_eb_window(m)               &
+                                          + surf_usm_v(l)%rad_sw_in(m)                     &
+                                            * (exp(-win_absorp                             &
+                                          * surf_usm_v(l)%zw_window(nzt_wall-1,m) )        &
+                                        - exp(-win_absorp                                  &
+                                            * surf_usm_v(l)%zw_window(nzt_wall,m) ) )      &
                                           ) * surf_usm_v(l)%ddz_window_stag(nzt_wall,m)
               ELSE
@@ -5377,7 +6486,7 @@
                                  * surf_usm_v(l)%ddz_window(kw,m)                      &
                               + surf_usm_v(l)%rad_sw_in(m)                             &
-                                 * (exp(-surf_usm_v(l)%transmissivity(m)            &
+                                 * (exp(-win_absorp                                    &
                                     * surf_usm_v(l)%zw_window(kw-1,m)       )          &
-                                        - exp(-surf_usm_v(l)%transmissivity(m)      &
+                                        - exp(-win_absorp                              &
                                         * surf_usm_v(l)%zw_window(kw,m) ) )            &
                                  ) * surf_usm_v(l)%ddz_window_stag(kw,m)
@@ -5390,4 +6499,5 @@
                                  * wintend(nzb_wall:nzt_wall) + tsc(3)           &
                                  * surf_usm_v(l)%tt_window_m(nzb_wall:nzt_wall,m) )   
+endif
 
 !
@@ -5407,4 +6517,7 @@
                   ENDIF
               ENDIF
+
+
+if (.NOT. spinup) then
 !--           calculate t_window tendencies for the next Runge-Kutta step
               IF ( timestep_scheme(1:5) == 'runge' )  THEN
@@ -5422,4 +6535,6 @@
                   ENDIF
               ENDIF
+endif
+
            ENDDO
         ENDDO
@@ -5441,9 +6556,25 @@
         INTEGER(iwp) ::  i,j,k,l,kw, m                      !< running indices
 
-        REAL(wp), DIMENSION(nzb_wall:nzt_wall) :: gtend  !< tendency
+        REAL(wp)     :: ke, lambda_h_green_sat
+        REAL(wp)     :: h_vg !< Van Genuchten coef. h
+        REAL(wp)     :: drho_l_lv
+
+        REAL(wp), DIMENSION(nzb_wall:nzt_wall) :: gtend,tend  !< tendency
+
+        REAL(wp), DIMENSION(nzb_wall:nzt_wall) :: root_extr_green
+
+        REAL(wp), DIMENSION(nzb_wall:nzt_wall+1) :: lambda_green_temp !< temp. lambda
+        REAL(wp), DIMENSION(nzb_wall:nzt_wall+1) :: gamma_green_temp !< temp. gamma
+
+        LOGICAL :: conserve_water_content = .true.
+
+
+        drho_l_lv = 1.0_wp / (rho_l * l_v)
 
 !
 !--     For horizontal surfaces                                   
         DO  m = 1, surf_usm_h%ns
+
+if (surf_usm_h%frac(ind_pav_green,m).gt.0.0_wp) then
 !
 !--        Obtain indices
@@ -5452,9 +6583,42 @@
            k = surf_usm_h%k(m)
 
+           DO  kw = nzb_wall, nzt_wall
+!
+!--           Calculate volumetric heat capacity of the soil, taking 
+!--           into account water content 
+              surf_usm_h%rho_c_total_green(kw,m) = (surf_usm_h%rho_c_green(kw,m) * (1.0_wp - swc_sat_h(kw,m)) &
+                                   + rho_c_water * swc_h(kw,m))
+   
+!
+!--           Calculate soil heat conductivity at the center of the soil
+!--           layers
+              lambda_h_green_sat = lambda_h_green_sm ** (1.0_wp - swc_sat_h(kw,m)) *    &
+                             lambda_h_water ** swc_h(kw,m)
+   
+              ke = 1.0_wp + LOG10(MAX(0.1_wp,swc_h(kw,m)             &
+                   / swc_sat_h(kw,m)))
+   
+              lambda_green_temp(kw) = ke * (lambda_h_green_sat - lambda_h_green_dry) +    &
+                               lambda_h_green_dry
+
+           ENDDO
+
+
+!
+!--        Calculate soil heat conductivity (lambda_h) at the _stag level 
+!--        using linear interpolation. For pavement surface, the
+!--        true pavement depth is considered
+           DO  kw = nzb_wall, nzt_wall
+             surf_usm_h%lambda_h_green(kw,m) = ( lambda_green_temp(kw+1) + lambda_green_temp(kw) )  &
+                                   * 0.5_wp
+           ENDDO
+!           surf_usm_h%lambda_h_green(nzt_wall+1,m) = lambda_green_temp(nzt_wall+1)           
+!--------------------------------------------------------------------------
+           
            t_green_h(nzt_wall+1,m) = t_wall_h(nzb_wall,m)
 !
 !--        prognostic equation for ground/roof temperature t_green_h
            gtend(:) = 0.0_wp
-           gtend(nzb_wall) = (1.0_wp / surf_usm_h%rho_c_green(nzb_wall,m)) *    &
+           gtend(nzb_wall) = (1.0_wp / surf_usm_h%rho_c_total_green(nzb_wall,m)) *    &
                                       ( surf_usm_h%lambda_h_green(nzb_wall,m) * &
                                         ( t_green_h(nzb_wall+1,m)               &
@@ -5465,5 +6629,5 @@
            
             DO  kw = nzb_wall+1, nzt_wall
-                gtend(kw) = (1.0_wp / surf_usm_h%rho_c_green(kw,m))             &
+                gtend(kw) = (1.0_wp / surf_usm_h%rho_c_total_green(kw,m))             &
                                * (   surf_usm_h%lambda_h_green(kw,m)            &
                                   * ( t_green_h(kw+1,m) - t_green_h(kw,m) )     &
